# FunKeyMonkey-pyrainput

A pyra input deamon based on FunKey-MonKey


### Install

Standard CMake stuff:

```
mkdir build
cd build
cmake ..
make
make install
```

### Configuration

All configurations should normally goes into /etc/pyrainput.cfg
syntax should be:
`<parameter> = <value>`

Values with `+` after them can have multiple values as space separated lists.

```
scripts.brightness.normal	= <path>
scripts.brightness.Fn		= <path>
scripts.brightness.Shift	= <path>
scripts.brightness.FnShift	= <path>
scripts.brightness.Alt		= <path>
scripts.brightness.Ctrl		= <path>
scripts.brightness.AltCtrl	= <path>
scripts.brightness.FnAlt	= <path>
scripts.brightness.FnCtrl	= <path>
scripts.brightness.ShiftAlt	= <path>
scripts.brightness.ShiftCtrl	= <path>
scripts.brightness.FnShiftAlt	= <path>
scripts.brightness.FnShiftCtrl	= <path>
scripts.commandmode.on          = <path>
scripts.commandmode.off         = <path>
profile.0                       = <path>
profile.1                       = <path>
profile.2                       = <path>
profile.3                       = <path>
profile.4                       = <path>
profile.5                       = <path>
profile.6                       = <path>
profile.7                       = <path>
profile.8                       = <path>
profile.9                       = <path>
profile.current                 = [0-9]
mouse.sensitivity		= 40
mouse.deadzone			= 20
mouse.wheel.sensitivity         = 75
mouse.wheel.deadzone		= 100
mouse.click.deadzone		= 100
nubs.deadzone			= 10
nubs.left.x			= [*mouse_x*|mouse_y|mouse_btn|scroll_x|scroll_y]+
nubs.left.y			= [mouse_x|*mouse_y*|mouse_btn|scroll_x|scroll_y]+
nubs.right.x			= [mouse_x|mouse_y|*mouse_btn*|scroll_x|scroll_y]+
nubs.right.y			= [mouse_x|mouse_y|mouse_btn|scroll_x|*scroll_y*]+
nubs.left.click			= [*mouse_left*|mouse_middle|mouse_right|nub_click_left|nub_click_right]+
nubs.right.click		= [mouse_left|mouse_middle|*mouse_right*|nub_click_left|nub_click_right]+
altmode.start.button    = [*left_alt*|right_alt]+
altmode.right.trigger   = [left_alt|*right_alt*]+
gamepad.export			= 1
keypad.export			= 1
mouse.export			= 1
```

Then reload configuration with:
```
systemctl reload pyrainput
```

### Command mode

Command mode is a special input mode for accessing more advanced pyrainput features. It can be toggled on and off using the key combination Fn+Pyra. Scripts `scripts.commandmode.on` and `scripts.commandmode.off` are run on entering/exiting command mode and can be used to signal the mode to the user.

#### Profiles

Profiles are extra configuration files that can be evaluated at runtime. By pressing a number key in command mode, the profile's configured file (`profile.0`...`profile.9`) is read and evaluated. This can be used to quickly change between multiple input configurations. To set a profile active from a configuration file, use `profile.current`.

### command lines for dbp packages


```
sudo /usr/sbin/pyrainputctl enable gamepad
sudo /usr/sbin/pyrainputctl disable gamepad

sudo /usr/sbin/pyrainputctl enable keypad
sudo /usr/sbin/pyrainputctl disable keypad

sudo /usr/sbin/pyrainputctl enable mouse
sudo /usr/sbin/pyrainputctl disable mouse

sudo /usr/sbin/pyrainputctl overload path/to/config.cfg
sudo /usr/sbin/pyrainputctl no-overload
```
